Bug fixed in install-openmano.sh to run config scripts from the appropriate base...
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27 # $1: database user
28 # $2: database password
29
30 function usage(){
31 echo -e "usage: sudo $0 [OPTIONS]"
32 echo -e "Install last stable source code in ./openmano and the needed packages"
33 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
34 echo -e " OPTIONS"
35 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
36 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
37 echo -e " -q --quiet: install in unattended mode"
38 echo -e " -h --help: show this help"
39 echo -e " --develop: install last version for developers, and do not configure as a service"
40 echo -e " --forcedb: reinstall mano_db DB, deleting previous database and creating a new one"
41 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
42 }
43
44 function install_packages(){
45 [ -x /usr/bin/apt-get ] && apt-get install -y $*
46 [ -x /usr/bin/yum ] && yum install -y $*
47
48 #check properly installed
49 for PACKAGE in $*
50 do
51 PACKAGE_INSTALLED="no"
52 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
53 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 if [ "$PACKAGE_INSTALLED" = "no" ]
55 then
56 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
57 exit 1
58 fi
59 done
60 }
61
62 function db_exists() {
63 RESULT=`mysqlshow --defaults-extra-file="$2" | grep -v Wildcard | grep -o $1`
64 if [ "$RESULT" == "$1" ]; then
65 echo " DB $1 exists"
66 return 0
67 fi
68 echo " DB $1 does not exist"
69 return 1
70 }
71
72 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
73 DBUSER="root"
74 DBPASSWD=""
75 DBPASSWD_PARAM=""
76 QUIET_MODE=""
77 DEVELOP=""
78 FORCEDB=""
79 NOCLONE=""
80 while getopts ":u:p:hiq-:" o; do
81 case "${o}" in
82 u)
83 export DBUSER="$OPTARG"
84 ;;
85 p)
86 export DBPASSWD="$OPTARG"
87 export DBPASSWD_PARAM="-p$OPTARG"
88 ;;
89 q)
90 export QUIET_MODE=yes
91 export DEBIAN_FRONTEND=noninteractive
92 ;;
93 h)
94 usage && exit 0
95 ;;
96 -)
97 [ "${OPTARG}" == "help" ] && usage && exit 0
98 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
99 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
100 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
101 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
102 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
103 exit 1
104 ;;
105 \?)
106 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
107 exit 1
108 ;;
109 :)
110 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
111 exit 1
112 ;;
113 *)
114 usage >&2
115 exit 1
116 ;;
117 esac
118 done
119
120 #check root privileges and non a root user behind
121 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
122 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
123 then
124 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
125 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
126 export SUDO_USER=root
127 fi
128
129 #Discover Linux distribution
130 #try redhat type
131 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
132 #if not assuming ubuntu type
133 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
134 if [ "$_DISTRO" == "Ubuntu" ]
135 then
136 _RELEASE=$(lsb_release -rs)
137 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
138 then
139 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
140 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
141 _RELEASE = 14
142 fi
143 elif [ "$_DISTRO" == "CentOS" ]
144 then
145 _RELEASE="7"
146 if ! cat /etc/redhat-release | grep -q "7."
147 then
148 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
149 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
150 fi
151 elif [ "$_DISTRO" == "Red" ]
152 then
153 _RELEASE="7"
154 if ! cat /etc/redhat-release | grep -q "7."
155 then
156 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
157 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
158 fi
159 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
160 _DISTRO_DISCOVER=$_DISTRO
161 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
162 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
163 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
164 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
165 fi
166
167
168
169 echo '
170 #################################################################
171 ##### UPDATE REPOSITORIES #####
172 #################################################################'
173 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
174
175 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
176 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
177 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
178 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
179 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
180
181
182 echo '
183 #################################################################
184 ##### INSTALL REQUIRED PACKAGES #####
185 #################################################################'
186 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-server"
187 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb mariadb-server"
188
189 if [[ "$_DISTRO" == "Ubuntu" ]]
190 then
191 #start services. By default CentOS does not start services
192 service mysql start >> /dev/null
193 # try to set admin password, ignore if fails
194 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
195 fi
196
197 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
198 then
199 #start services. By default CentOS does not start services
200 service mariadb start
201 service httpd start
202 systemctl enable mariadb
203 systemctl enable httpd
204 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
205 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
206
207 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
208 [ "$KK" != "n" -a "$KK" != "no" ] &&
209 firewall-cmd --permanent --zone=public --add-service=http &&
210 firewall-cmd --permanent --zone=public --add-service=https &&
211 firewall-cmd --reload
212 fi
213
214 #check and ask for database user password. Must be done after database installation
215 if [[ -n $QUIET_MODE ]]
216 then
217 echo -e "\nCheking database connection and ask for credentials"
218 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM status >/dev/null
219 do
220 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
221 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
222 read -e -p "database user? ($DBUSER) " DBUSER_
223 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
224 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
225 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
226 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
227 logintry="yes"
228 done
229 fi
230
231 echo '
232 #################################################################
233 ##### INSTALL PYTHON PACKAGES #####
234 #################################################################'
235 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils"
236 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils"
237
238 #The only way to install python-bottle on Centos7 is with easy_install or pip
239 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
240
241 #install openstack client needed for using openstack as a VIM
242 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient"
243 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient #TODO revise if gcc python-pip is needed
244
245 if [[ -z $NOCLONE ]]; then
246 echo '
247 #################################################################
248 ##### DOWNLOAD SOURCE #####
249 #################################################################'
250 su $SUDO_USER -c 'git clone '"${GIT_URL}"' openmano'
251 #[[ -z $DEVELOP ]] && su $SUDO_USER -c 'git checkout <tag version>'
252 fi
253
254 echo '
255 #################################################################
256 ##### CREATE DATABASE #####
257 #################################################################'
258 echo -e "\nCreating temporary file form MYSQL installation and initialization"
259 TEMPFILE="$(mktemp -q --tmpdir "installopenmano.XXXXXX")"
260 trap 'rm -f "$TEMPFILE"' EXIT
261 chmod 0600 "$TEMPFILE"
262 cat >"$TEMPFILE" <<EOF
263 [client]
264 user=$DBUSER
265 password=$DBPASSWD
266 EOF
267
268 if db_exists "mano_db" $TEMPFILE ; then
269 if [[ -n $FORCEDB ]]; then
270 echo " Deleting previous database mano_db"
271 DBDELETEPARAM=""
272 [[ -n $QUIET_MODE ]] && DBDELETEPARAM="-f"
273 mysqladmin --defaults-extra-file=$TEMPFILE -s drop mano_db $DBDELETEPARAM || ! echo "Could not delete mano_db database" || exit 1
274 #echo "REVOKE ALL PRIVILEGES ON mano_db.* FROM 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
275 #echo "DELETE USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
276 mysqladmin --defaults-extra-file=$TEMPFILE -s create mano_db || ! echo "Error creating mano_db database" || exit 1
277 echo "DROP USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
278 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
279 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
280 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
281 else
282 echo "Database exists. Use option '--forcedb' to force the deletion of the existing one" && exit 1
283 fi
284 else
285 mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || ! echo "Error creating mano_db database" || exit 1
286 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
287 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
288 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
289 fi
290
291
292 #Next operations require knowing OPENMANO_BASEFOLDER
293 HERE=$(realpath $(dirname $0))
294 if [[ -z $NOCLONE ]]; then
295 OPENMANO_BASEFOLDER="${HERE}/openmano"
296 else
297 OPENMANO_BASEFOLDER=$(dirname $HERE)
298 fi
299
300
301 echo '
302 #################################################################
303 ##### INIT DATABASE #####
304 #################################################################'
305 su $SUDO_USER -c "${OPENMANO_BASEFOLDER}"'/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db' || ! echo "Failed while initializing database" || exit 1
306
307
308 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
309 then
310 echo '
311 #################################################################
312 ##### CONFIGURE firewalld #####
313 #################################################################'
314 KK=yes
315 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
316 if [ "$KK" != "n" -a "$KK" != "no" ]
317 then
318 #Creates a service file for openmano
319 echo '<?xml version="1.0" encoding="utf-8"?>
320 <service>
321 <short>openmanod</short>
322 <description>openmanod service</description>
323 <port protocol="tcp" port="9090"/>
324 </service>' > /etc/firewalld/services/openmanod.xml
325 #put proper permissions
326 pushd /etc/firewalld/services > /dev/null
327 restorecon openmanod.xml
328 chmod 640 openmanod.xml
329 popd > /dev/null
330 #Add the openmanod service to the default zone permanently and reload the firewall configuration
331 firewall-cmd --permanent --add-service=openmanod > /dev/null
332 firewall-cmd --reload > /dev/null
333 echo "done."
334 else
335 echo "skipping."
336 fi
337 fi
338
339 echo '
340 #################################################################
341 ##### CONFIGURE OPENMANO CLIENT #####
342 #################################################################'
343 #creates a link at ~/bin
344 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
345 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
346 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
347 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
348 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/openmano ${HOME}/bin/openmano'
349 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/openmano-report.sh ${HOME}/bin/openmano-report'
350 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/service-openmano.sh ${HOME}/bin/service-openmano'
351
352 #insert /home/<user>/bin in the PATH
353 #skiped because normally this is done authomatically when ~/bin exist
354 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
355 #then
356 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
357 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
358 #fi
359 if [[ $SUDO_USER == root ]]
360 then
361 if ! echo $PATH | grep -q "${HOME}/bin"
362 then
363 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
364 fi
365 fi
366
367 #configure arg-autocomplete for this user
368 #in case of minimal instalation this package is not installed by default
369 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
370 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
371 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
372 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
373 then
374 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
375 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
376 fi
377
378
379
380
381 if [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]]
382 then
383 echo '
384 #################################################################
385 ##### CONFIGURE OPENMANO SERVICE #####
386 #################################################################'
387
388 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} #-u $SUDO_USER
389 # alias service-openmano="service openmano"
390 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
391
392 echo
393 echo "Done! you may need to logout and login again for loading client configuration"
394 echo " Manage server with 'service openmano start|stop|status|...' "
395
396
397 else
398
399 echo
400 echo "Done! you may need to logout and login again for loading client configuration"
401 echo " Run './openmano/scripts/service-openmano.sh start' for starting openmano in a screen"
402
403 fi
404
405
406